
using System;

namespace Calculator
{

	/// <summary>
	/// Visitor interface. Implement this interface to add new kinds of visitors performing additional operations on the node hierarchy
	/// </summary>
	public interface IVisitor
	{
		/// <summary>
		/// Visit an operand
		/// </summary>
		/// <param name="op">
		/// A <see cref="Operand"/>
		/// </param>
		void Visit(Operand op);
		/// <summary>
		/// Visit operator "+"
		/// </summary>
		/// <param name="opt">
		/// A <see cref="PlusOperator"/>
		/// </param>
		void Visit(PlusOperator opt);
		/// <summary>
		/// Visit operator "-"
		/// </summary>
		/// <param name="opt">
		/// A <see cref="MinusOperator"/>
		/// </param>
		void Visit(MinusOperator opt);
		/// <summary>
		/// Visit operator "*"
		/// </summary>
		/// <param name="opt">
		/// A <see cref="TimesOperator"/>
		/// </param>
		void Visit(TimesOperator opt);
		/// <summary>
		/// Visit operator "/"
		/// </summary>
		/// <param name="opt">
		/// A <see cref="DivideByOperator"/>
		/// </param>
		void Visit(DivideByOperator opt);
	}
}
