
using System;

namespace Calculator
{

	/// <summary>
	/// Operator "+"
	/// </summary>
	public class PlusOperator:Operator
	{
		/// <summary>
		/// Plus operator constructor
		/// </summary>
		public PlusOperator():base("+")
		{}
		/// <summary>
		/// Implement double dispatch using this operator and the specific visitor passed as argument
		/// </summary>
		/// <param name="v">
		/// A <see cref="IVisitor"/>
		/// </param>
		public override void Accept(IVisitor v)
		{
			v.Visit(this);
		}
	}
}
	
